LeetCode 2645.构造有效字符串的最少插入数:O(n) + O(1)

【LetMeFly】2645.构造有效字符串的最少插入数:O(n) + O(1)

力扣题目链接:https://leetcode.cn/problems/minimum-additions-to-make-valid-string/

给你一个字符串 word ,你可以向其中任何位置插入 "a"、"b" 或 "c" 任意次,返回使 word 有效 需要插入的最少字母数。

如果字符串可以由 "abc" 串联多次得到,则认为该字符串 有效 。

示例 1:

复制代码
输入:word = "b"
输出:2
解释:在 "b" 之前插入 "a" ,在 "b" 之后插入 "c" 可以得到有效字符串 "abc" 。

示例 2:

复制代码
输入:word = "aaa"
输出:6
解释:在每个 "a" 之后依次插入 "b" 和 "c" 可以得到有效字符串 "abcabcabc" 。

示例 3:

复制代码
输入:word = "abc"
输出:0
解释:word 已经是有效字符串,不需要进行修改。 

提示:

  • 1 <= word.length <= 50
  • word 仅由字母 "a"、"b" 和 "c" 组成。

方法一:if-else

从前到后遍历字符串,并补充最少的字符使所有字符都变成abc:

  • 如果当前字符为a:
    • 如果附近字符格式为axx,则ans += 2(a后插入bc)
    • 如果附近字符格式为abx,则ans++; i++;(ab后插入c)
    • 如果附近字符格式为abc,则i += 2
    • 如果附近字符格式为ac,则ans++; i++;(ac中插入b)
  • 如果当前字符为b:
    • 如果附近字符格式为xbx,则ans += 2;(b前后插入ac)
    • 如果附近字符格式为xbc,则ans++; i++;(b前插入a)
  • 如果当前字符为c:
    • 附近字符格式只能为xxc,则ans += 2(c前插入ab)

最终返回ans即为答案。

  • 时间复杂度 O ( l e n ( w o r d ) ) O(len(word)) O(len(word))
  • 空间复杂度 O ( 1 ) O(1) O(1)

AC代码

C++
cpp 复制代码
class Solution {
public:
    int addMinimum(string word) {
        int ans = 0;
        for (int i = 0; i < word.size(); i++) {
            if (word[i] == 'a') {  // axx abx abc ac
                if (i + 2 < word.size() && word[i + 1] == 'b' && word[i + 2] == 'c') {  // abc
                    i += 2;
                }
                else if (i + 1 < word.size() && word[i + 1] == 'c') {  // ac
                    i++;
                    ans++;
                }
                else if (i + 1 < word.size() && word[i + 1] == 'b') {  // abx
                    i++;
                    ans++;
                }
                else {  // axx
                    ans += 2;
                }
            }
            else if (word[i] == 'b') {  // xbx xbc
                if (i + 1 < word.size() && word[i + 1] == 'c') {  // xbc
                    i++;
                    ans++;
                }
                else {  // xbx
                    ans += 2;
                }
            }
            else {  // xxc
                ans += 2;
            }
        }
        return ans;
    }
};

方法二:算最终是几个abc

有童鞋说这道题只有三个字符,如果有10个字符(abcdefghij)那得写多少if-else。

没办法了,换个更容易实现的方法吧。

不难发现,目标字符串abc是递增的,只要连续两个字符是递增的,那么它们必定可以划到一个abc中。(若连续两字符为ab、ac、bc,那么他们最终会在一个abc中)。

否则(第二个字符≤第一个字符),相邻两个字符只能处在两个abc中。

因此,我们只需要遍历以便字符串,看相邻两个字符中第二个字符≤第一个字符的个数,就能知道最终有多少个abc。

最终abc的个数乘3减去现有字符串长度即为要添加的字符的个数。

  • 时间复杂度 O ( l e n ( w o r d ) ) O(len(word)) O(len(word))
  • 空间复杂度 O ( 1 ) O(1) O(1)

AC代码

C++
cpp 复制代码
class Solution {
public:
    int addMinimum(string word) {
        int cntABC = 1;
        for (int i = 1; i < word.size(); i++) {
            if (word[i] <= word[i - 1]) {
                cntABC++;
            }
        }
        return cntABC * 3 - word.size();
    }
};
Python
python 复制代码
class Solution:
    def addMinimum(self, word: str) -> int:
        cntABC = 1
        for i in range(1, len(word)):
            if word[i] <= word[i - 1]:
                cntABC += 1
        return cntABC * 3 - len(word)

同步发文于CSDN,原创不易,转载经作者同意后请附上原文链接哦~

Tisfy:https://letmefly.blog.csdn.net/article/details/135531917

相关推荐
Dream it possible!10 小时前
LeetCode 面试经典 150_多维动态规划_交错字符串(97_C++_中等)
算法·leetcode·面试·动态规划
心抵鹊11 小时前
算法之双指针系列(一)
算法·leetcode
十二11 小时前
【洛谷题解】P1083 [NOIP 2012 提高组] 借教室(二分答案 + 差分)
数据结构·c++·算法·蓝桥杯
小此方12 小时前
[算法实战论:动态规划]回文串问题的dp解法,回文串问题的母题,以及以此为基础的派生题
算法·动态规划
Pniubi13 小时前
力扣560.和为k的子数组
算法·leetcode·职场和发展
D e re k ZH13 小时前
C++ 从零入门(一):基础语法与程序结构
数据结构·c++·算法
Pniubi13 小时前
力扣438.找到字符串中所有字母异位词
算法·leetcode·职场和发展
東隅已逝,桑榆非晚16 小时前
算法6. 双指针法-查找总价格为目标的两个商品
c++·学习·算法
Eyfcom16 小时前
〖物联网终端实战 01〗UWB 室内高精度定位:仓储 AGV 与人员的厘米级轨迹追踪
物联网·算法·物流系统·快递系统·跨境物流快递系统·物联网终端实战
bro_Java66617 小时前
《排序的底层逻辑:比较、交换与分治》
java·算法·排序算法